<?php


namespace FiloBlu\PaymentMethodFilter\Helper;

use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Store\Model\ScopeInterface;

class PaymentFilter extends AbstractHelper
{

    const FILTER_ENABLE_CONFIG_PATH = 'payment_method_filter/default/enable';
    const WHITELISTED_METHODS_CONFIG_PATH = 'payment_method_filter/default/whitelist_payment_methods';
    const FILTER_CONDITION_CONFIG_PATH = 'payment_method_filter/default/filter_condition';

    /**
     * @param \Magento\Framework\App\Helper\Context $context
     */
    public function __construct(
        \Magento\Framework\App\Helper\Context $context
    ) {
        parent::__construct($context);
    }

    public function isFilterEnabled() {
        return $this->scopeConfig->isSetFlag(self::FILTER_ENABLE_CONFIG_PATH, ScopeInterface::SCOPE_WEBSITE);
    }

    public function paymentMethodWhitelist() {
        $list = [];
        if ($this->scopeConfig->getValue(self::WHITELISTED_METHODS_CONFIG_PATH, ScopeInterface::SCOPE_WEBSITE) != '') {
            $list = explode(',', $this->scopeConfig->getValue(self::WHITELISTED_METHODS_CONFIG_PATH, ScopeInterface::SCOPE_WEBSITE));
        }
        return $list;
    }

    public function quoteContainsGiftcard($quote) {
        if (is_null($quote) == FALSE) {
            foreach ($quote->getAllItems() as $item) {
                if ($item->getProductType() == 'giftcard') {
                    return TRUE;
                }
            }
        }
        return FALSE;
    }

    public function getFilterconditions() {
        $conditions = [];
        $filterCondition = $this->scopeConfig->getValue(self::FILTER_CONDITION_CONFIG_PATH, ScopeInterface::SCOPE_WEBSITE);
        if (!is_null($filterCondition)) {
            $conditions = explode(',', $filterCondition);
        }
        return $conditions;
    }
}